//---------------------------------------------------------------------------

#ifndef ic_mainH
#define ic_mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "CPort.hpp"
#include "CPortCtl.hpp"
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <AppEvnts.hpp>
#include <Graphics.hpp>

#include "textitem.h"
#include <ToolWin.hpp>
#include <Dialogs.hpp>
#include <ImgList.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TComPort *cport;
	TStatusBar *StatusBar1;
	TMainMenu *menu;
	TMenuItem *File1;
	TMenuItem *Exit1;
	TGroupBox *gb_list;
	TGroupBox *GroupBox3;
	TLabel *Label1;
	TComComboBox *ComComboBox1;
	TCheckBox *cbConnected;
	TApplicationEvents *events;
	TImage *modeimages;
	TListBox *lb_list;
	TPopupMenu *pm_lbox;
	TMenuItem *Add1;
	TPopupMenu *pm_modesel;
	TMenuItem *m1;
	TMenuItem *m2;
	TMenuItem *m3;
	TMenuItem *m4;
	TMenuItem *m5;
	TMenuItem *m6;
	TMenuItem *m7;
	TMemo *inplace_edit;
	TButton *btn_send;
	TProgressBar *progress;
	TMenuItem *m8;
	TMenuItem *m9;
	TMenuItem *m10;
	TMenuItem *m11;
	TMenuItem *m12;
	TMenuItem *m13;
	TMenuItem *m14;
	TMenuItem *New1;
	TMenuItem *Open1;
	TMenuItem *N1;
	TMenuItem *Save1;
	TMenuItem *SaveAs1;
	TMenuItem *Ediut1;
	TMenuItem *Additem1;
	TMenuItem *Deleteitem1;
	TMenuItem *N2;
	TMenuItem *MoveUp1;
	TMenuItem *MoveDown1;
	TSaveDialog *dlgSave;
	TOpenDialog *dlgOpen;
	TToolBar *ToolBar1;
	TMenuItem *Deleteitem2;
	TImageList *ImageList1;
	TToolButton *ToolButton1;
	TToolButton *ToolButton2;
	TToolButton *ToolButton3;
	TToolButton *ToolButton4;
	TMenuItem *N3;
	TMenuItem *Moveup2;
	TMenuItem *Movedown2;
	void __fastcall eventsIdle(TObject *Sender, bool &Done);
	void __fastcall cbConnectedClick(TObject *Sender);
	void __fastcall Exit1Click(TObject *Sender);
	void __fastcall on_create(TObject *Sender);
	void __fastcall on_destroy(TObject *Sender);
	void __fastcall Add1Click(TObject *Sender);
	void __fastcall on_draw_item(TWinControl *Control, int Index, TRect &Rect,
          TOwnerDrawState State);
	void __fastcall on_resize(TObject *Sender);
	void __fastcall m1DrawItem(TObject *Sender, TCanvas *ACanvas,
          TRect &ARect, bool Selected);
	void __fastcall m1MeasureItem(TObject *Sender, TCanvas *ACanvas,
          int &Width, int &Height);
	void __fastcall lb_listMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall mode_selected(TObject *Sender);
	void __fastcall inplace_editExit(TObject *Sender);
	void __fastcall lb_listDblClick(TObject *Sender);
	void __fastcall inplace_editKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall btn_sendClick(TObject *Sender);
	void __fastcall Save1Click(TObject *Sender);
	void __fastcall SaveAs1Click(TObject *Sender);
	void __fastcall New1Click(TObject *Sender);
	void __fastcall Open1Click(TObject *Sender);
	void __fastcall MoveUp1Click(TObject *Sender);
	void __fastcall MoveDown1Click(TObject *Sender);
	void __fastcall Deleteitem1Click(TObject *Sender);
	void __fastcall lb_listKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
private:
	TList * FList;
	TTextItem * __fastcall GetTextItems(int index);	// User declarations
public:
	int FPopOverItem;
	int FEditIndex;
	AnsiString FFileName;
	__fastcall TForm1(TComponent* Owner);
	void __fastcall NewTextItem();
	int __fastcall AddTextItem(TTextItem * item);
	TTextItem * __fastcall DelTextItem(int index);
	TTextItem * __fastcall RemTextItem(TTextItem * item);
	void __fastcall InvalItem(int index);
	void __fastcall BeginEditTextItem(int index);
	void __fastcall EndEditTextItem();
	void __fastcall PlaceInplaceEditor(int index);
	TRect __fastcall InplaceEditorRect(int index);
	bool __fastcall TextHit(TCanvas * cnv, int xTx, int yTx, TPoint pt, AnsiString tx);
	void __fastcall SaveDocument(AnsiString fname);
	void __fastcall LoadDocument(AnsiString fname);
	__property TList * List  = { read=FList };
	__property TTextItem * TextItems[int index]  = { read=GetTextItems };
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
